/******************************************************************************
*******************************************************************************
**                                                                           **
**      MOST for C Swing and Gopher - A file viewer                          **
**                                                                           **
*******************************************************************************
**                                                                           **
**      Original C coding by: John E. Davis                                  **
**                                                                           **
**      Modifications primarily by Foteos Macrides                           **
**                                                                           **
**      Copyright 1991, John E. Davis                                        **
**                                                                           **
**      Terms of Copyright: See MAIN.C                                       **
**                                                                           **
**      Disclaimer: No warranties as to the use or reliability of this       **
**          software are given by the authors or distributors.  Use at       **
**          your own risk.                                                   **
**                                                                           **
*******************************************************************************
******************************************************************************/
/*
 *  MOST:  externs.h
 *
 *  Modified for C SWING and GOPHER compatibility by Foteos Macrides
 *                                                MACRIDES@SCI.WFEB.EDU
 */

#ifdef VMS
#ifndef __DECC
/*
**  VAXC speed me ups
*/
#define malloc	VAXC$MALLOC_OPT
#define calloc  VAXC$CALLOC_OPT
#define free	VAXC$FREE_OPT
#define cfree	VAXC$CFREE_OPT
#define realloc	VAXC$REALLOC_OPT
#endif
#endif

extern int NUM_LINES;
extern int ACTUAL_LINES;
extern int CURS_ROW;
extern int CURS_COL;
extern unsigned char *CURS_POS;

extern int MOST_B_OPT;          /* display Binary File */
extern int MOST_C_OPT;          /* case-sensitive searches */
extern int MOST_D_OPT;          /* delete file mode  (see ':D') */
extern int MOST_H_OPT;          /* for -h switch:  most most.doc_fm */
extern int MOST_K_OPT;          /* Kanji option */
extern int MOST_L_OPT;          /* use ^L (formfeed) to clear screen */
extern int MOST_N_OPT;          /* use naive prompt instead of file name */
extern int MOST_S_OPT;          /* squeeze multiple blank lines to one */
extern int MOST_T_OPT;          /* display tab as ^I-- valid only with V option */
extern int MOST_V_OPT;          /* display control chars as ^ch */
extern int MOST_W_OPT;          /* wrap lines if true */
extern int STARTING_LINE;       /* starting line for initial display */
extern int EDT_DIRECTION;       /* for toggling EDT-style FORWARD/REVERSE */
extern int SEARCH_DIR;          /* for toggling direction of string searches */
extern char SEARCH_STR[];       /* for setting starting line based on a string */
extern int SELECTIVE_I_DISPLAY; /* selective indentation display */
extern int NEXT_RING_FILE;      /* for cycling through file ring */
extern int SecureMode;          /* for disabling spawn, edit, and get new file */
extern char MOST_DOCFILE[];     /* full filespec for most.doc_fm */

#define _MOST_V_OPT  1
#define _MOST_T_OPT  2
#define _MOST_B_OPT  4
#define _MOST_SQ_OPT 8
#define _MOST_W_OPT 16
