/******************************************************************************
*******************************************************************************
**                                                                           **
**      MOST for C Swing and Gopher - A file viewer                          **
**                                                                           **
*******************************************************************************
**                                                                           **
**      Original C coding by: John E. Davis                                  **
**                                                                           **
**      Modifications primarily by Foteos Macrides                           **
**                                                                           **
**      Copyright 1991, John E. Davis                                        **
**                                                                           **
**      Terms of Copyright: See MAIN.C                                       **
**                                                                           **
**      Disclaimer: No warranties as to the use or reliability of this       **
**          software are given by the authors or distributors.  Use at       **
**          your own risk.                                                   **
**                                                                           **
*******************************************************************************
******************************************************************************/
/*
 *  MOST:  keym.c
 *
 *  Modified for C SWING and GOPHER compatibility by Foteos Macrides
 *                                                MACRIDES@SCI.WFEB.EDU
 */

#include <stdio.h>
#include "externs.h"  
#include "keym.h"
#include "sysdep.h"
#include "display.h"
#include "buffer.h"
#include "window.h"
#include "search.h"

int *DIGIT_ARG;
char LAST_CHAR;
globalref int exit_most;

void (*root_map[128])() =
  {
      beep_cmd,                 /* ^@ */
      beep_cmd,                 /* ^A */
      beep_cmd,                 /* ^B */
      beep_cmd,                 /* ^C */
      beep_cmd,                 /* ^D */
      beep_cmd,                 /* ^E */
      beep_cmd,                 /* ^F */
      beep_cmd,                 /* ^G */
      beep_cmd,                 /* ^H */
      beep_cmd,                 /* ^I */
      next_line_cmd,            /* ^J */
      beep_cmd,                 /* ^K */
      beep_cmd,                 /* ^L */
#ifdef VMS
      page_down_cmd,            /* ^M */
#else
      next_line_cmd,            /* ^M */
#endif
      beep_cmd,                 /* ^N */
      beep_cmd,                 /* ^O */
      beep_cmd,                 /* ^P */
      beep_cmd,                 /* ^Q */
      redraw_cmd,               /* ^R */
      beep_cmd,                 /* ^S */
      time_cmd,                 /* ^T */
      beep_cmd,                 /* ^U */
      beep_cmd,                 /* ^V */
      redraw_cmd,               /* ^W */
      pf1_map_cmd,              /* ^X */
      beep_cmd,                 /* ^Y */
      exit_cmd,                 /* ^Z */
      esc_map_cmd,              /* ^[ */
      beep_cmd,                 /* ^\ */
      beep_cmd,                 /* ^] */
      beep_cmd,                 /* ^^ */
      beep_cmd,                 /* ^_ */
      page_down_cmd,            /*   */
      beep_cmd,                 /* ! */
      beep_cmd,                 /* " */
      beep_cmd,                 /* # */
      sys_spawn_cmd,            /* $ */
      goto_percent_cmd,         /* % */
      beep_cmd,                 /* & */
      beep_cmd,                 /* ' */
      beep_cmd,                 /* ( */
      beep_cmd,                 /* ) */
      beep_cmd,                 /* * */
      beep_cmd,                 /* + */
      beep_cmd,                 /* , */
      digit_arg_cmd,            /* - */
      goto_mark_cmd,            /* . */
      search_cmd,               /* / */
      digit_arg_cmd,            /* 0 */
      digit_arg_cmd,            /* 1 */
      digit_arg_cmd,            /* 2 */
      digit_arg_cmd,            /* 3 */
      digit_arg_cmd,            /* 4 */
      digit_arg_cmd,            /* 5 */
      digit_arg_cmd,            /* 6 */
      digit_arg_cmd,            /* 7 */
      digit_arg_cmd,            /* 8 */
      digit_arg_cmd,            /* 9 */
      extended_key_cmd,         /* : */
      beep_cmd,                 /* ; */
      page_left_cmd,            /* < */
      beep_cmd,                 /* = */
      page_right_cmd,           /* > */
      help_cmd,                 /* ? */
      beep_cmd,                 /* @ */
      beep_cmd,                 /* A */
      end_of_buffer_cmd,        /* B */
      beep_cmd,                 /* C */
      next_line_cmd,            /* D */
      edit_cmd,                 /* E */
      beep_cmd,                 /* F */
      goto_line_cmd,            /* G */
      help_cmd,                 /* H */
      beep_cmd,                 /* I */
      next_line_cmd,            /* J */
      previous_line_cmd,        /* K */
      toggle_lock,              /* L */
      set_mark_cmd,             /* M */
      page_down_cmd,            /* N */
      other_window_cmd,         /* O */
      page_up_cmd,              /* P */
      exit_cmd,                 /* Q */
      find_next_cmd,            /* R */
      beep_cmd,                 /* S */
      top_of_buffer_cmd,        /* T */
      previous_line_cmd,        /* U */
      beep_cmd,                 /* V */
      toggle_width_cmd,         /* W */
      exit_cmd,                 /* X */
      beep_cmd,                 /* Y */
      beep_cmd,                 /* Z */
      beep_cmd,                 /* [ */
      search_back_cmd,          /* \ */
      beep_cmd,                 /* ] */
      beep_cmd,                 /* ^ */
      beep_cmd,                 /* _ */
      beep_cmd,                 /* ` */
      beep_cmd,                 /* a */
      end_of_buffer_cmd,        /* b */
      beep_cmd,                 /* c */
      next_line_cmd,            /* d */
      edit_cmd,                 /* e */
      beep_cmd,                 /* f */
      goto_line_cmd,            /* g */
      help_cmd,                 /* h */
      beep_cmd,                 /* i */
      next_line_cmd,            /* j */
      previous_line_cmd,        /* k */
      toggle_lock,              /* l */
      set_mark_cmd,             /* m */
      page_down_cmd,            /* n */
      other_window_cmd,         /* o */
      page_up_cmd,              /* p */
      exit_cmd,                 /* q */
      find_next_cmd,            /* r */
      beep_cmd,                 /* s */
      top_of_buffer_cmd,        /* t */
      previous_line_cmd,        /* u */
      beep_cmd,                 /* v */
      toggle_width_cmd,         /* w */
      exit_cmd,                 /* x */
      beep_cmd,                 /* y */
      beep_cmd,                 /* z */
      beep_cmd,                 /* { */
      beep_cmd,                 /* | */
      beep_cmd,                 /* } */
      beep_cmd,                 /* ~ */
      beep_cmd                  /* ^? */
    };

/*  escape map  */
void (*escape_map[128])() =
  {
      beep_cmd,                 /* ^@ */
      beep_cmd,                 /* ^A */
      beep_cmd,                 /* ^B */
      beep_cmd,                 /* ^C */
      beep_cmd,                 /* ^D */
      beep_cmd,                 /* ^E */
      beep_cmd,                 /* ^F */
      beep_cmd,                 /* ^G */
      beep_cmd,                 /* ^H */
      beep_cmd,                 /* ^I */
      beep_cmd,                 /* ^J */
      beep_cmd,                 /* ^K */
      beep_cmd,                 /* ^L */
      beep_cmd,                 /* ^M */
      beep_cmd,                 /* ^N */
      beep_cmd,                 /* ^O */
      beep_cmd,                 /* ^P */
      beep_cmd,                 /* ^Q */
      beep_cmd,                 /* ^R */
      beep_cmd,                 /* ^S */
      beep_cmd,                 /* ^T */
      beep_cmd,                 /* ^U */
      beep_cmd,                 /* ^V */
      beep_cmd,                 /* ^W */
      beep_cmd,                 /* ^X */
      beep_cmd,                 /* ^Y */
      beep_cmd,                 /* ^Z */
      beep_cmd,                 /* ^[ */
      beep_cmd,                 /* ^\ */
      beep_cmd,                 /* ^] */
      beep_cmd,                 /* ^^ */
      beep_cmd,                 /* ^_ */
      beep_cmd,                 /*   */
      beep_cmd,                 /* ! */
      beep_cmd,                 /* " */
      beep_cmd,                 /* # */
      beep_cmd,                 /* $ */
      beep_cmd,                 /* % */
      beep_cmd,                 /* & */
      beep_cmd,                 /* ' */
      beep_cmd,                 /* ( */
      beep_cmd,                 /* ) */
      beep_cmd,                 /* * */
      beep_cmd,                 /* + */
      beep_cmd,                 /* , */
      digit_arg_cmd,            /* - */
      beep_cmd,                 /* . */
      beep_cmd,                 /* / */
      beep_cmd,                 /* 0 */
      digit_arg_cmd,            /* 1 */
      digit_arg_cmd,            /* 2 */
      digit_arg_cmd,            /* 3 */
      digit_arg_cmd,            /* 4 */
      digit_arg_cmd,            /* 5 */
      digit_arg_cmd,            /* 6 */
      digit_arg_cmd,            /* 7 */
      digit_arg_cmd,            /* 8 */
      digit_arg_cmd,            /* 9 */
      beep_cmd,                 /* : */
      beep_cmd,                 /* ; */
      beep_cmd,                 /* < */
      beep_cmd,                 /* = */
      beep_cmd,                 /* > */
      beep_cmd,                 /* ? */
      beep_cmd,                 /* @ */
      beep_cmd,                 /* A */
      beep_cmd,                 /* B */
      beep_cmd,                 /* C */
      beep_cmd,                 /* D */
      beep_cmd,                 /* E */
      beep_cmd,                 /* F */
      beep_cmd,                 /* G */
      beep_cmd,                 /* H */
      beep_cmd,                 /* I */
      beep_cmd,                 /* J */
      beep_cmd,                 /* K */
      beep_cmd,                 /* L */
      beep_cmd,                 /* M */
      beep_cmd,                 /* N */
      O_map_cmd,                /* O */
      beep_cmd,                 /* P */
      beep_cmd,                 /* Q */
      beep_cmd,                 /* R */
      beep_cmd,                 /* S */
      beep_cmd,                 /* T */
      beep_cmd,                 /* U */
      beep_cmd,                 /* V */
      beep_cmd,                 /* W */
      beep_cmd,                 /* X */
      beep_cmd,                 /* Y */
      beep_cmd,                 /* Z */
      O_map_cmd,                /* [ */
      beep_cmd,                 /* \ */
      beep_cmd,                 /* ] */
      beep_cmd,                 /* ^ */
      beep_cmd,                 /* _ */
      beep_cmd,                 /* ` */
      beep_cmd,                 /* a */
      beep_cmd,                 /* b */
      beep_cmd,                 /* c */
      beep_cmd,                 /* d */
      beep_cmd,                 /* e */
      beep_cmd,                 /* f */
      beep_cmd,                 /* g */
      beep_cmd,                 /* h */
      beep_cmd,                 /* i */
      beep_cmd,                 /* j */
      beep_cmd,                 /* k */
      beep_cmd,                 /* l */
      beep_cmd,                 /* m */
      beep_cmd,                 /* n */
      beep_cmd,                 /* o */
      beep_cmd,                 /* p */
      beep_cmd,                 /* q */
      beep_cmd,                 /* r */
      beep_cmd,                 /* s */
      beep_cmd,                 /* t */
      beep_cmd,                 /* u */
      beep_cmd,                 /* v */
      beep_cmd,                 /* w */
      beep_cmd,                 /* x */
      beep_cmd,                 /* y */
      beep_cmd,                 /* z */
      beep_cmd,                 /* { */
      beep_cmd,                 /* | */
      beep_cmd,                 /* } */
      beep_cmd,                 /* ~ */
      beep_cmd                  /* ^? */
  };

void (*esc_O_map[128])() =
  {
      beep_cmd,                 /* ^@ */
      beep_cmd,                 /* ^A */
      beep_cmd,                 /* ^B */
      beep_cmd,                 /* ^C */
      beep_cmd,                 /* ^D */
      beep_cmd,                 /* ^E */
      beep_cmd,                 /* ^F */
      beep_cmd,                 /* ^G */
      beep_cmd,                 /* ^H */
      beep_cmd,                 /* ^I */
      beep_cmd,                 /* ^J */
      beep_cmd,                 /* ^K */
      beep_cmd,                 /* ^L */
      beep_cmd,                 /* ^M */
      beep_cmd,                 /* ^N */
      beep_cmd,                 /* ^O */
      beep_cmd,                 /* ^P */
      beep_cmd,                 /* ^Q */
      beep_cmd,                 /* ^R */
      beep_cmd,                 /* ^S */
      beep_cmd,                 /* ^T */
      beep_cmd,                 /* ^U */
      beep_cmd,                 /* ^V */
      beep_cmd,                 /* ^W */
      beep_cmd,                 /* ^X */
      beep_cmd,                 /* ^Y */
      beep_cmd,                 /* ^Z */
      beep_cmd,                 /* ^[ */
      beep_cmd,                 /* ^\ */
      beep_cmd,                 /* ^] */
      beep_cmd,                 /* ^^ */
      beep_cmd,                 /* ^_ */
      beep_cmd,                 /*   */
      beep_cmd,                 /* ! */
      beep_cmd,                 /* " */
      beep_cmd,                 /* # */
      beep_cmd,                 /* $ */
      beep_cmd,                 /* % */
      beep_cmd,                 /* & */
      beep_cmd,                 /* ' */
      beep_cmd,                 /* ( */
      beep_cmd,                 /* ) */
      beep_cmd,                 /* * */
      beep_cmd,                 /* + */
      beep_cmd,                 /* , */
      beep_cmd,                 /* - */
      beep_cmd,                 /* . */
      beep_cmd,                 /* / */
      dec_extended_map_cmd,     /* 0 */
      dec_extended_map_cmd,     /* 1 */
      dec_extended_map_cmd,     /* 2 */
      dec_extended_map_cmd,     /* 3 */
      dec_extended_map_cmd,     /* 4 */
      dec_extended_map_cmd,     /* 5 */
      dec_extended_map_cmd,     /* 6 */
      dec_extended_map_cmd,     /* 7 */
      dec_extended_map_cmd,     /* 8 */
      dec_extended_map_cmd,     /* 9 */
      beep_cmd,                 /* : */
      beep_cmd,                 /* ; */
      beep_cmd,                 /* < */
      beep_cmd,                 /* = */
      beep_cmd,                 /* > */
      beep_cmd,                 /* ? */
      beep_cmd,                 /* @ */
      previous_line_cmd,        /* A */ /*    UP_ARROW */
      next_line_cmd,            /* B */ /*  DOWN_ARROW */
      page_right_cmd,           /* C */ /* RIGHT_ARROW */
      page_left_cmd,            /* D */ /*  LEFT_ARROW */
      beep_cmd,                 /* E */
      beep_cmd,                 /* F */
      beep_cmd,                 /* G */
      beep_cmd,                 /* H */
      beep_cmd,                 /* I */
      beep_cmd,                 /* J */
      beep_cmd,                 /* K */
      beep_cmd,                 /* L */
#ifdef VMS
      page_down_cmd,            /* M */ /* KP ENTER */
#else
      next_line_cmd,            /* M */ /* KP ENTER */
#endif
      beep_cmd,                 /* N */
      beep_cmd,                 /* O */
      pf1_map_cmd,              /* P */ /* PF1 */
      help_cmd,                 /* Q */ /* PF2 */
      edt_find_next_cmd,        /* R */ /* PF3 */
      beep_cmd,                 /* S */ /* PF4 */
      beep_cmd,                 /* T */
      beep_cmd,                 /* U */
      beep_cmd,                 /* V */
      beep_cmd,                 /* W */
      beep_cmd,                 /* X */
      beep_cmd,                 /* Y */
      beep_cmd,                 /* Z */
      beep_cmd,                 /* [ */
      beep_cmd,                 /* \ */
      beep_cmd,                 /* ] */
      beep_cmd,                 /* ^ */
      beep_cmd,                 /* _ */
      beep_cmd,                 /* ` */
      beep_cmd,                 /* a */
      beep_cmd,                 /* b */
      beep_cmd,                 /* c */
      beep_cmd,                 /* d */
      beep_cmd,                 /* e */
      beep_cmd,                 /* f */
      beep_cmd,                 /* g */
      beep_cmd,                 /* h */
      beep_cmd,                 /* i */
      beep_cmd,                 /* j */
      beep_cmd,                 /* k */
      beep_cmd,                 /* l */ /* KPcomma */
      beep_cmd,                 /* m */ /* KPminus */
      set_mark_cmd,             /* n */ /* KPdot   */
      beep_cmd,                 /* o */
      edt_line_cmd,             /* p */ /* KP0 */
      beep_cmd,                 /* q */ /* KP1 */
      beep_cmd,                 /* r */ /* KP2 */
      beep_cmd,                 /* s */ /* KP3 */
      edt_forward_cmd,          /* t */ /* KP4 */
      edt_back_cmd,             /* u */ /* KP5 */
      beep_cmd,                 /* v */ /* KP6 */
      beep_cmd,                 /* w */ /* KP7 */
      edt_page_cmd,             /* x */ /* KP8 */
      beep_cmd,                 /* y */ /* KP9 */
      beep_cmd,                 /* z */
      beep_cmd,                 /* { */
      beep_cmd,                 /* | */
      beep_cmd,                 /* } */
      beep_cmd,                 /* ~ */
      beep_cmd                  /* ^? */
  };

void (*pf1_map[128])() =	/* Gold */
  {
      beep_cmd,                 /* ^@ */
      beep_cmd,                 /* ^A */
      beep_cmd,                 /* ^B */
      beep_cmd,                 /* ^C */
      beep_cmd,                 /* ^D */
      beep_cmd,                 /* ^E */
      beep_cmd,                 /* ^F */
      beep_cmd,                 /* ^G */
      beep_cmd,                 /* ^H */
      beep_cmd,                 /* ^I */
      extended_cmd_cmd,         /* ^J */
      beep_cmd,                 /* ^K */
      beep_cmd,                 /* ^L */
      extended_cmd_cmd,         /* ^M */
      beep_cmd,                 /* ^N */
      beep_cmd,                 /* ^O */
      beep_cmd,                 /* ^P */
      beep_cmd,                 /* ^Q */
      beep_cmd,                 /* ^R */
      beep_cmd,                 /* ^S */
      beep_cmd,                 /* ^T */
      beep_cmd,                 /* ^U */
      beep_cmd,                 /* ^V */
      beep_cmd,                 /* ^W */
      beep_cmd,                 /* ^X */
      beep_cmd,                 /* ^Y */
      beep_cmd,                 /* ^Z */
      pf1_esc_map_cmd,          /* ^[ */
      beep_cmd,                 /* ^\ */
      beep_cmd,                 /* ^] */
      beep_cmd,                 /* ^^ */
      beep_cmd,                 /* ^_ */
      beep_cmd,                 /*   */
      beep_cmd,                 /* ! */
      beep_cmd,                 /* " */
      beep_cmd,                 /* # */
      beep_cmd,                 /* $ */
      beep_cmd,                 /* % */
      beep_cmd,                 /* & */
      beep_cmd,                 /* ' */
      beep_cmd,                 /* ( */
      beep_cmd,                 /* ) */
      beep_cmd,                 /* * */
      beep_cmd,                 /* + */
      beep_cmd,                 /* , */
      beep_cmd,                 /* - */
      goto_mark_cmd,            /* . */
      beep_cmd,                 /* / */
      del_window_cmd,           /* 0 */
      one_window_cmd,           /* 1 */
      two_window_cmd,           /* 2 */
      beep_cmd,                 /* 3 */
      beep_cmd,                 /* 4 */
      beep_cmd,                 /* 5 */
      beep_cmd,                 /* 6 */
      beep_cmd,                 /* 7 */
      beep_cmd,                 /* 8 */
      beep_cmd,                 /* 9 */
      beep_cmd,                 /* : */
      beep_cmd,                 /* ; */
      beep_cmd,                 /* < */
      beep_cmd,                 /* = */
      beep_cmd,                 /* > */
      help_doc_cmd,             /* ? */
      beep_cmd,                 /* @ */
      beep_cmd,                 /* A */
      beep_cmd,                 /* B */
      beep_cmd,                 /* C */
      beep_cmd,                 /* D */
      beep_cmd,                 /* E */
      beep_cmd,                 /* F */
      find_file_cmd,            /* G */
      help_doc_cmd,             /* H */
      beep_cmd,                 /* I */
      beep_cmd,                 /* J */
      beep_cmd,                 /* K */
      beep_cmd,                 /* L */
      set_mark_cmd,             /* M */
      beep_cmd,                 /* N */
      other_window_cmd,         /* O */
      beep_cmd,                 /* P */
      exit_cmd,                 /* Q */
      edt_find_cmd,             /* R */
      sys_spawn_cmd,            /* S */
      beep_cmd,                 /* T */
      beep_cmd,                 /* U */
      beep_cmd,                 /* V */
      beep_cmd,                 /* W */
      exit_cmd,                 /* X */
      beep_cmd,                 /* Y */
      beep_cmd,                 /* Z */
      beep_cmd,                 /* [ */
      beep_cmd,                 /* \ */
      beep_cmd,                 /* ] */
      beep_cmd,                 /* ^ */
      beep_cmd,                 /* _ */
      beep_cmd,                 /* ` */
      beep_cmd,                 /* a */
      beep_cmd,                 /* b */
      beep_cmd,                 /* c */
      beep_cmd,                 /* d */
      beep_cmd,                 /* e */
      beep_cmd,                 /* f */
      find_file_cmd,            /* g */
      help_doc_cmd,             /* h */
      beep_cmd,                 /* i */
      beep_cmd,                 /* j */
      beep_cmd,                 /* k */
      beep_cmd,                 /* l */
      set_mark_cmd,             /* m */
      beep_cmd,                 /* n */
      other_window_cmd,         /* o */
      beep_cmd,                 /* p */
      exit_cmd,                 /* q */
      edt_find_cmd,             /* r */
      sys_spawn_cmd,            /* s */
      beep_cmd,                 /* t */
      beep_cmd,                 /* u */
      beep_cmd,                 /* v */
      beep_cmd,                 /* w */
      exit_cmd,                 /* x */
      beep_cmd,                 /* y */
      beep_cmd,                 /* z */
      beep_cmd,                 /* { */
      beep_cmd,                 /* | */
      beep_cmd,                 /* } */
      beep_cmd,                 /* ~ */
      beep_cmd                  /* ^? */
  };

void execute_key()
{
    char ch;
    int r,c;
    c = CURS_COL - COLUMN + 1;
    r = CURS_ROW;
    if (MINI_BUF[0] != '\0') put_message();
    if (r < 1) r = 1;
    else if (r > (WIN->bot - WIN->top + 1))
      r = WIN->bot - WIN->top + 1;
    if (c > SCREEN_WIDTH) c = SCREEN_WIDTH;
    else if (c < 1) c = 1;
    goto_rc(r,c);
    fflush(stdout);
    DIGIT_ARG = (int *) NULL;
    ch = getkey();
    if (MINI_BUF[0] != '\0') clear_minibuffer();
    LAST_CHAR = ch;
    (*root_map[ (int) ch ])();
}

void O_map_cmd()
{
    char ch;

    ch = getkey();
    LAST_CHAR = ch;
    (*esc_O_map[ (int) ch ])();
}

void esc_map_cmd()
{
    char ch;

    ch = getkey();
    LAST_CHAR = ch;
    (*escape_map[ (int) ch ])();
}

/* weird sequences of form ^[[n~ where n is an integer */
void dec_extended_map_cmd()
{
    char ch, numstr[5];
    int i, num;
    
    ch = LAST_CHAR;  /* should be integer */
    i = 0;
    numstr[i++] = ch;
 
    while (ch = getkey(), isdigit(ch)) numstr[i++] = ch;
    if (ch == '~')
      {
          numstr[i++] =  '\0';
          sscanf(numstr,"%d",&num);
          switch (num)
            {
              case 5:
                page_up_cmd(); break; /* prev screen */
              case 6:
                page_down_cmd(); break; /* next screen */
              case 1:
                search_cmd(); break; /* find */
              case 4:
                set_mark_cmd(); break; /* select */
              case 2:   
                goto_mark_cmd(); break; /* insert here */
              case 28:
                help_cmd(); break; /* Help */
              case 29:  /* do */
                extended_cmd_cmd(); break;
              default:
                beep_cmd(); break;
            }
      }
    else beep_cmd();
}

/* sequences of form ^[[Ol or ^[[l where l is a letter */
void pf1_esc_map_cmd()
{
    char ch, numstr[5];
    int i, num;
    
    LAST_CHAR = ch = getkey();
    switch (ch)
	{
	case 'O': /** keypad **/
	    LAST_CHAR = ch = getkey();
	    switch (ch)
		{
		case 'n': /* KPdot */
		    goto_mark_cmd(); break;
		case 'p': /* KP0 */
		    del_window_cmd(); break;
		case 'q': /* KP1 */
		    one_window_cmd(); break;
		case 'r': /* KP2 */
		    two_window_cmd(); break;
		case 't': /* KP4 */
		    end_of_buffer_cmd(); break;
		case 'u': /* KP5 */
		    top_of_buffer_cmd(); break;
		case 'w': /* KP7 */
		    extended_cmd_cmd(); break;
		case 'Q': /* PF2 */
		    help_doc_cmd(); break;
		case 'R': /* PF3 */
		    edt_find_cmd(); break;
		default :
		    beep_cmd(); break;
		}
	    break;
	case '[': /** arrow keys **/
	    LAST_CHAR = ch = getkey();
	    switch (ch)
		{
		case 'A':
		    other_window_cmd(); break;
		case 'B':
		    other_window_cmd(); break;
		case 'C':
		    page_left_cmd(); break;
		case 'D':
		    page_right_cmd(); break;
		default :
		    beep_cmd(); break;
		};
	    break;
	default :
            beep_cmd(); break;
	}
}

void pf1_map_cmd()
{
    char ch;

    ch = getkey();
    LAST_CHAR = ch;
    (*pf1_map[ (int) ch ])();
}

void beep_cmd()
{
    fputc('\007',stdout);
}

void page_down_cmd()
{
    int n = 1;
    if (DIGIT_ARG != (int *) NULL) n = *DIGIT_ARG;
    update_windows(C_LINE + n * (WIN->bot - WIN->top + 1));
}
void page_up_cmd()
{
    int n = 1;
    if (DIGIT_ARG != (int *) NULL) n = *DIGIT_ARG;
    update_windows(C_LINE - n * (WIN->bot - WIN->top + 1));
}

void page_right_cmd()
{
    int n = 1;

    if (MOST_W_OPT)
      {
          most_message("You are in wrap mode.",1);
          return;
      }
    if (DIGIT_ARG != (int *) NULL) n = *DIGIT_ARG;
    COLUMN = COLUMN + n * 59;
    update_windows(C_LINE);
}

void page_left_cmd()
{
    int n = 1;

    if (MOST_W_OPT)
      {
          most_message("You are in wrap mode.",1);
          return;
      }
    if (DIGIT_ARG != (int *) NULL) n = *DIGIT_ARG;
    COLUMN = COLUMN - n * 59;
    update_windows(C_LINE);
}

void next_line_cmd()
{
    int n = 1;
    if (DIGIT_ARG != (int *) NULL) n = *DIGIT_ARG;
    update_windows(C_LINE + n);
}

void previous_line_cmd()
{
    int n = 1;
    if (DIGIT_ARG != (int *) NULL) n = *DIGIT_ARG;
    update_windows(C_LINE - n);
}

void top_of_buffer_cmd()
{
    update_windows(1);
}

void end_of_buffer_cmd()
{
    update_windows(NUM_LINES);
}

extern void sys_spawn_cmd()
{
    int update = 0;
    globalref int captive;

    if (captive)
      {
          most_message("Function disabled for captive accounts.",1);
          return;
      }

    if (SecureMode)
      {
          most_message("Sorry, you are not allowed to spawn in secure mode.",1);
	  return;
      }

    if (reset_most_tty())
      {
         if (most_restored_width)
              redraw_display();
         reset_display();
         fflush(stdout);
#ifdef VMS
         if (LAST_CHAR == '\032') return; /* ^Z */
         if (-1 == do_shell_command()) exit_cmd();
#else                          
         killpg(getpgrp(0),18);
#endif
         if (init_most_tty())
              redraw_display();
         else
           {
              fputs("\nError re-initializing the terminal!!!\n", stderr);
	      exit_cmd();
           }
      }
}

void redraw_cmd()
{
    redraw_display();
}

void goto_line_cmd()
{
    int n = C_LINE;
    if (DIGIT_ARG != (int *) NULL) n = *DIGIT_ARG;
    else
      {
          MINI_BUF[0] = 0;
          if (!read_from_minibuffer("Line: ", MINI_BUF)) return;
          sscanf(MINI_BUF,"%d",&n);
          MINI_BUF[0] = 0;
      }
    update_windows(n);
}

void goto_percent_cmd()
{
    unsigned char *pos;
    int n;
    if (DIGIT_ARG != (int *) NULL) n = *DIGIT_ARG;
    else
      {
          MINI_BUF[0] = 0;
          if (!read_from_minibuffer("%: ", MINI_BUF)) return;
          sscanf(MINI_BUF,"%d",&n);
          MINI_BUF[0] = 0;
      }
    if (n < 0) n = 0; else if (n > 100) n = 100;
    pos = BEG + (int) (n * (int) (EOB - BEG)) / 100;
    n = what_line(pos);
    update_windows(n);
}

void edit_cmd()
{
    if (-1 == do_edit_command()) exit_cmd();
}

void extended_key_cmd()
{
    if (-1 == do_extended_key()) exit_cmd();
}

void extended_cmd_cmd()
{
    if (-1 == do_extended_cmd()) exit_cmd();
}

void set_mark_cmd()
{
    BUF->mark = C_LINE;
    most_message("Mark Set.",0);
}

void goto_mark_cmd()
{
    int mark = BUF->mark;
    BUF->mark = C_LINE;
    if (!mark || mark == BUF->mark)
      most_message("Mark Set.",0);
    else
      {
          update_window(mark);
          most_message("Mark Set.  Toggled to previous mark.",0);
      }
}

void one_window_cmd()
{
    one_window();
}

void two_window_cmd()
{
    two_windows();
}

void del_window_cmd()
{
    delete_window();
}

void other_window_cmd()
{
    int n = 1;
    if (DIGIT_ARG != (int *) NULL) n = *DIGIT_ARG;
    other_window(n);
}


void find_next_cmd()
{
    int col, line, n = 1;
    unsigned char *pos;
    
    if (SELECTIVE_I_DISPLAY)
      {
          most_message
               ("Search disabled when Selective Indentation Display is set",1);
          return;
      }
    if (DIGIT_ARG != NULL) n = *DIGIT_ARG;
    line = search(CURS_POS + SEARCH_DIR, n, &col);
    if (line < 1) return;
    pos = CURS_POS;
    if ((line < WIN->beg_line) || (line > WIN->beg_line + WIN->bot - WIN->top))
      update_window(line);
    CURS_POS = pos;
    CURS_ROW = line - C_LINE + 1;
    CURS_COL = col;
}

void search_cmd()
{
    if (SELECTIVE_I_DISPLAY)
      {
          most_message
               ("Search disabled when Selective Indentation Display is set",1);
          return;
      }
    SEARCH_DIR = 1;
    EDT_DIRECTION = 1;
    if (read_from_minibuffer("Search /",SEARCH_STR) == -1)
      {
          most_message("Search cancelled",0);
          return;
      }
    else
      {
          CURS_POS = C_POS;
          find_next_cmd();
      }
}

void search_back_cmd()
{
    if (SELECTIVE_I_DISPLAY)
      {
          most_message
               ("Search disabled when Selective Indentation Display is set",1);
          return;
      }
    SEARCH_DIR = -1;
    EDT_DIRECTION = 0;
    if (read_from_minibuffer("Search \\",SEARCH_STR) == -1)
      {
          most_message("Search cancelled",0);
          return;
      }
    else
      {
          find_next_cmd();
      }
}

void help_cmd()
{
    do_help_command();
}

void help_doc_cmd()
{
    if (-1 == do_help_doc_command()) exit_cmd();
}

void find_file_cmd()
{
    if (SecureMode)
      {
          most_message("Sorry, this command is disabled in secure mode.",1);
	  return;
      }

    user_get_file();
}

void time_cmd()
{
    most_message(most_get_time(),0);
}

void exit_cmd()
{

    exit_most = 1;
    if (reset_most_tty())
         if (most_restored_width)
              redraw_display();
    reset_display();
#ifdef  VMS
    if (most_restored_width)
         goto_rc(SCREEN_HEIGHT,1);
    else
         goto_rc(SCREEN_ROWS,1);
    most_restored_width = 0;
#endif
    return;
}

void digit_arg_cmd()
{
    char num[15], ch;
    int j = 0;
    static int digits;
    
    num[j++] = LAST_CHAR;
    ch = getkey();
    while ((ch >= '0') && (ch <= '9'))
      {
          num[j++] = ch;
          ch = getkey();
      }
    
    if (((j == 1) && (LAST_CHAR != '-')) || (j > 1))
      {
          num[j] = '\0';
          sscanf(num,"%d",&digits);
          DIGIT_ARG = &digits;
      }
    LAST_CHAR = ch;
    (*root_map[ (int) ch ])();
}


void toggle_width_cmd()
{
    if (SCREEN_WIDTH == 80)
      {
          set_width(132, 1);
          most_message("Display Width toggled to 132.",0);
      }          
    else if (SCREEN_WIDTH == 132)
      {
          set_width(80, 1);
          most_message("Display Width toggled to 80.",0);
      }
    else
      most_message("Width can only be toggled for 80 or 132 column windows",1);
}

void edt_forward_cmd()
{
    EDT_DIRECTION = 1;
    SEARCH_DIR = 1;
}

void edt_back_cmd()
{
    EDT_DIRECTION = 0;
    SEARCH_DIR = -1;
}

void edt_page_cmd()
{
    if (EDT_DIRECTION == 0)
	{
	    page_up_cmd();
	}
    else
	{
	    page_down_cmd();
	}
}

void edt_line_cmd()
{
    if (EDT_DIRECTION == 0)
	{
	    previous_line_cmd();
	}
    else
	{
	    next_line_cmd();
	}
}

void edt_find_cmd()
{
    if (EDT_DIRECTION == 0)
	{
	    search_back_cmd();
	}
    else
	{
	    search_cmd();
	}
}

void edt_find_next_cmd()
{
    if (EDT_DIRECTION == 0)
	{
	    SEARCH_DIR = -1;
	}
    else
	{
	    SEARCH_DIR = 1;
	}
    find_next_cmd();
}
